/**************************************************************************************

        PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
        AUTHOR : See AUTHORS file for details

        This software is distributed under the terms of the GNU General Public License
        as specified in the COPYING file.

***************************************************************************************/

#ifndef BUSMONITOR_HH
#define BUSMONITOR_HH

#include <mustux.h>

class Interface;

class BusMonitor : public MustuxEngine
        {
        Q_OBJECT

        public :
                static const int MAX_CHANNELS_PER_BUS = 2;

                BusMonitor(MustuxDrawable*, Interface* pAssocInterface);
                ~BusMonitor();

                void init();
                void refresh();

        public slots:
                void update();

        private :
                MustuxDrawable* drawable;
                Interface* assocInterface;

                int levelIn [MustuxAudioDeviceMapper::MAX_BUSES][MAX_CHANNELS_PER_BUS];
                int levelOut[MustuxAudioDeviceMapper::MAX_BUSES][MAX_CHANNELS_PER_BUS];
                QTimer* updateTimer;

                void draw_bus_vu_base(int bx , int by , int channels, int pos , QString title, bool isActiveBus);
                void draw_bus_vu_peaks(int stream, int* levelBuffer, int bx, int by, int channels, int pos);
        };


#include "Interface.hh"

#endif



