/**************************************************************************************

        PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
        AUTHOR : See AUTHORS file for details

        This software is distributed under the terms of the GNU General Public License
        as specified in the COPYING file.

***************************************************************************************/

#include "ColorManager.hh"

namespace ColorManager
        {
        QColor color[MAX_COLORS];
        bool blur[MAX_COLORS];
        }

void ColorManager::init()
        {
        for (int i=0; i<=MAX_COLORS; i++)
                {
                color[i].setRgb(0,0,0);
                blur[i]=false;
                }
        
        color[COLOR_TRACK_BG                          ].setRgb(60, 65, 73);
        color[COLOR_TRACK_ACTIVE_BORDER               ].setRgb(255, 0, 0);
        color[COLOR_CLIP_RECORDING                    ].setRgb(231,31,11);
        color[COLOR_CLIP_BG                           ].setRgb(205,220,210);
        color[COLOR_CLIP_SELECTED_BG                  ].setRgb(101,111,171);
        color[COLOR_CLIP_MUTED_BG                     ].setRgb(40,40,40);
        color[COLOR_CLIP_INFO_AREA_BG                 ].setRgb(199,190,218);
        color[COLOR_CLIP_PEAK_MICROVIEW_FG            ].setRgb(100,0,20);
        color[COLOR_CLIP_PEAK_MACROVIEW_FG            ].setRgb(80,80,120);
        color[COLOR_CLIP_TEXT_FG                      ].setRgb(60, 65, 73);
        color[COLOR_CLIP_PEAK_OVERLOADED_SAMPLE       ].setRgb(255,0,0);
        color[COLOR_TRACK_PANEL_BG_COLOR              ].setRgb(190,205,210);
        color[COLOR_TRACK_PANEL_FG_COLOR              ].setRgb(20,0,0);
        color[COLOR_TRACK_PANEL_GREEN                 ].setRgb(40,255,40);
        color[COLOR_TRACK_PANEL_RED                   ].setRgb(255,40,40);

        }



QColor ColorManager::get(int colorIndex)
        {
        if (blur[colorIndex])
                {
                QColor x;
                QColor c = color[colorIndex];
                int r = c.red();
                int g = c.green();
                int b = c.blue();

                float fr = (float) r / 255;
                float fg = (float) g / 255;
                float fb = (float) b / 255;

                int dr = (int)(20*fr);
                int dg = (int)(20*fg);
                int db = (int)(20*fb);

                r=160+dr;
                g=160+dg;
                b=180+db;

                x.setRgb(r,g,b);
                return x;
                }
        else
                return color[colorIndex];
        }

void ColorManager::set_blur(int index, bool stat)
        {
        blur[index]=stat;
        }

//eof
