#include "Gain.hh"


Gain::Gain(int pSampleRate, int pChannels) : AudioFilter(pSampleRate, pChannels)
        {
        wetOut=1;
        }

Gain::~Gain()
        {
        }


int Gain::load_data(   char* audioFragment, int audioFragmentSize)
        {
        fragment = audioFragment;
        fragmentSize = audioFragmentSize;
        return 1;
        }

int Gain::prepare()
        {
        return 1;
        }

        
void Gain::set_gain(float g)
        {
        g=g>MAX_GAIN ? MAX_GAIN : g;
        g=g<0.0 ? 0.0 : g;
        gain=g;
        }
        
float Gain::get_gain()
        {
        return gain;
        }

int Gain::process() // IMPROVE-ME. threshold level and release time
                         // must be dinamically read from the curve
        {
        char* p = fragment;  
        char* lastp = p + fragmentSize;
        while (p<lastp)
                {
                for (int k=0; k<channels; k++)
                        {
                        short* psho = (short*)p;
                        short sample = *(psho);
                        float fsample = (float) sample * wetOut;
                        CHECK_SAMPLE_OVERLOAD(fsample);
                        *(psho)= (short) fsample;
                        p+=sizeof(short);
                        }
                }
        return 1;
        }

//eof
