#include <math.h>
#include "GainController.hh"
#include <math.h>
#include <mustux.h>

GainController::GainController(Song* pParentSong, MustuxDrawable* pDrawArea, AudioFilter* pFilter )
        : FilterController(pParentSong, pDrawArea, pFilter)
        {
        PENTERCONS;
        Curve* c = add_curve("Amount");
        curveAmountIndex = get_curve_index(c);
        PEXITCONS;
        }

GainController::~GainController()
        {
        // standard routine to delete curves. Copy it to all xxxxController.cc destructors.
        for (int i=0; i<MAX_CURVES; i++)
                if (curve[i]) delete curve[i];
        }

void GainController::node_setup()
        {
        curve[currentCurveIndex]->get_current_curve_node()->setup();
        }


void GainController::setup()
        {
        FilterController::setup();
        }

QString GainController::get_type()
        {
        return "Gain";
        }

int GainController::get_baseX()
        {
        return baseX;
        }


int GainController::get_baseY()
        {
        return baseY;
        }

int GainController::get_width()
        {
        return drawArea->width();
        }

int GainController::get_height()
        {
        return height;
        }

void GainController::set_baseX(int initialValue)
        {
        baseX=initialValue;
        }

void GainController::set_baseY(int initialValue)
        {
        baseY=initialValue;
        }

void GainController::set_width(int initialValue)
        {
        width=initialValue;
        }

void GainController::set_height(int initialValue)
        {
        height=initialValue;
        }

void GainController::draw()
        {
        PENTER;
        FilterController::draw();
        PEXIT;
        }

int GainController::process(char* data, int size)
        {
        float v = curve[curveAmountIndex]->get_value_at(parentSong->get_playing_block());
        float vdb = v*25/100;
        float gain = (vdb>=0.0)? 1.0f + vdb/6.0f : 1.0f / pow(2.0f,-1.0f*vdb/6.0f);
        assocFilter->set_wet_out(gain);
        if (assocFilter->load_data(data,size)<0) return -1;
        if (assocFilter->prepare()<0) return -1;
        if (assocFilter->process()<0) return -1;
        return 1;
        }
//eof
